﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win.Misc;
using Infragistics.Win.SupportDialogs.RibbonCustomizationProvider;
using Infragistics.Win.UltraWinToolbars;
using Infragistics.Win.UltraWinTree;

namespace RibbonCustomizationProvider
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void ultraRibbonCustomizationProvider1_BeforeCustomizationDialogDisplayed(object sender, Infragistics.Win.SupportDialogs.RibbonCustomizationProvider.BeforeCustomizationDialogDisplayedEventArgs e)
        {
            RibbonCustomizationControl RCcontrol = e.Dialog.TabControl.Tabs[0].TabPage.Controls[0] as RibbonCustomizationControl;
            RemoveAddingCustomTabsInRibbonCustomizationDialog(RCcontrol, "btnAddTab", "NewTab", "Create a New Group");                    
        }

        private void RemoveAddingCustomTabsInRibbonCustomizationDialog(Control control, string buttonTabName, 
            string contextMenuNewTabItemKey, string treeItemNewGroup)
        {
            if (control is UltraToolbarsDockArea)
            {
                ((UltraToolbarsDockArea)control).ToolbarsManager.Tools[contextMenuNewTabItemKey].SharedProps.Visible = false;
            }

            if (control is UltraPanel)
            {
                foreach (Control c in ((UltraPanel)control).ClientArea.Controls)
                {
                    // Remove the button, if found
                    if (c is UltraButton && c.Name == buttonTabName)
                        ((UltraPanel)control).ClientArea.Controls.Remove(c);
                    // Remove the Add Group, if found                    
                    else if (c is UltraTree)
                    {
                        this.RemoveTreeItem(((UltraTree)c).Nodes, treeItemNewGroup);
                    }
                    else
                        RemoveAddingCustomTabsInRibbonCustomizationDialog(c, buttonTabName, contextMenuNewTabItemKey, treeItemNewGroup);
                }
            }
            else
            {
                foreach (Control c in control.Controls)
                {
                    // Remove the button, if found
                    if (c is UltraButton && c.Name == buttonTabName)
                        control.Controls.Remove(c);
                    // Remove the Add Group, if found
                    else if (c is UltraTree)       
                    {
                        this.RemoveTreeItem(((UltraTree)c).Nodes, treeItemNewGroup);
                    }
                    else
                        RemoveAddingCustomTabsInRibbonCustomizationDialog(c, buttonTabName, contextMenuNewTabItemKey, treeItemNewGroup);
                }
            }
        }

        private void RemoveTreeItem(TreeNodesCollection treeNodes, string treeItemText)
        {
            foreach (UltraTreeNode node in treeNodes)
            {
                if (node.Text.Contains(treeItemText))
                {
                    node.Remove();
                }
                else
                {
                    RemoveTreeItem(node.Nodes, treeItemText);
                }
            }
        }        
    }
}